@echo off
CD /D "%~dp0"

::===========  get Compiler ar path  =============
if not exist $$$ (
	call .\path\which arm-none-eabi-ar > $$$
)
set /p string=<$$$


::======== get Compiler installed path and check length ==========
::  the %length% must bigger than 25
::       1234567890123456789012345
:: 25 is \bin\arm-none-eabi-ar.exe
if not defined string GOTO NO_PATH
set string=%string:~0,-25%
if not defined string GOTO NO_PATH


if "%string%" EQU "%GHOME%" Goto install

echo ===============================================
echo.
echo   * WARNING ! *
echo.
echo ===============================================
echo.
echo   This Library will be install to [ GHOME ]   
echo.
echo   Please check the GHOME path is correct. 
echo.
echo   ( GHOME path must equal Compiler path )
echo.
echo.
echo   GHOME    path = %GHOME%
echo   Compiler path = %string%
echo.
echo.
echo -----------------------------------------------

Set input=
:Begin
REM echo input [C] copy Compiler path to GHOME ,then intsall (Only for Windows XP)
echo input [Y] to install to GHOME
Set /P input="input [Enter] to exit : "
If /I "%input%"=="Y" Echo "continue..." && Goto install
REM If /I "%input%"=="C" Echo "set GHOME..." && Goto add_Env_VAR
Goto end

:install
REM VER:1.02
echo Install...
echo.

:: backup file
REM copy "%GHOME%\bin\*.bat" backup\bin\ 
REM copy "%GHOME%\include\*.h" backup\inc\ 
REM copy "%GHOME%\lib\8600lib.a" backup\lib\ 
copy /Y bin\*.exe "%GHOME%\bin\"
if "%ERRORLEVEL%" NEQ "0" (
	if exist "%temp%\getadmin.vbs" (
		del "%temp%\getadmin.vbs"
		echo Fail to copy file to GHOME, please check your system.
		goto end
	) else (
		echo Unable to copy file, requesting administrative privileges...
		goto UACPrompt
	)
) else (
	if exist "%temp%\getadmin.vbs" ( del "%temp%\getadmin.vbs" )
)
copy /Y bin\*.bat "%GHOME%\bin\"

MD  "%GHOME%\include\"
copy /Y inc\*.h "%GHOME%\include\"

copy /Y append\inc.txt "%GHOME%\arm-none-eabi\include\"
copy /Y append\stdio.h "%GHOME%\arm-none-eabi\include\"
copy /Y append\CIPHER_UDF.h "%GHOME%\arm-none-eabi\include\"

copy /Y lib\_LIB_Ver.bat "%GHOME%\lib\"
copy /Y lib\8600lib.a "%GHOME%\lib\8600lib.a"
REM @call "%GHOME%\lib\_LIB_Ver.bat"

@echo off
echo.
echo.
echo ===============================================
echo.
echo     Installation is complete.
echo.
echo     Please Remember restart you computer.
echo.
echo ===============================================
echo.
echo.

@GOTO end


:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    echo UAC.ShellExecute "%~s0", "", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    exit /B


:add_Env_VAR:
::====== add Environment Var ================

.\path\setx GHOME "%string%" -m
echo.
echo.
echo.
echo GHOME is Create.
echo Please Run Install again.
echo.
goto end

:NO_PATH
echo =============================================== 
echo.
echo  Please check the Compiler path is correct. 
echo.
echo ===============================================


    

:end 
    del /q $$$

pause

